#!/usr/bin/python
# -*- coding: UTF-8 -*-

import time, random, urlparse, hmac, base64
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer
from hashlib import sha1

PORT_NUMBER = 8081
SECRET_ID = ''
SECRET_KEY = ''

class myHandler(BaseHTTPRequestHandler):
    def do_GET(self):
        o = urlparse.urlparse(self.path)
        #获取fileId
        query_map = urlparse.parse_qs(o.query)
        if 'fileId' not in query_map:
            self.send_response(400)
            self.end_headers()
            return         
        file_id = query_map["fileId"][0]

        self.send_response(200)
        self.send_header('Access-Control-Allow-Origin','*')
        self.send_header('Access-Control-Allow-Methods','POST, GET, OPTIONS, PUT, DELETE')
        self.send_header('Access-Control-Allow-Headers','Range, Accept, Content-Type, Content-Length, Accept-Encoding, X-CSRF-Token, Authorization')
        self.send_header('Content-type','text/html')
        self.end_headers()

        #构造明文串
        duration = 24 * 3600
        current_time_stamp = int(time.time()) 
        expire_time_stamp = current_time_stamp + duration
        random_num = int(random.random() * (2**32))
        plain = "SecretId=%s&CurrentTimeStamp=%d&ExpireTimeStamp=%d&Random=%d&FileId=%s" % (SECRET_ID, current_time_stamp, expire_time_stamp, random_num, file_id)
        print 'plain: ', plain

        #使用SecretKey进行HMAC-SHA1加密
        hmac_code = hmac.new(SECRET_KEY.encode(), plain.encode(), sha1).digest()
        token_code = hmac_code + plain.encode()
        token = base64.b64encode(token_code)
        self.wfile.write(token)
        print 'token: ', token

        return

if __name__ == "__main__":
    try:
        server = HTTPServer(('', PORT_NUMBER), myHandler)
        print 'Started httpserver on port ', PORT_NUMBER
        server.serve_forever()
    except KeyboardInterrupt:
        print '^C received, shutting down the web server'
        server.socket.close()
